function bplanck,nnu,TT
nu=nnu*1.d0
T=TT*1.d0
cc=2.9979d10
hh=6.6262d-27
kk=1.3807e-16
n=n_elements(nu)
bpl=dblarr(n)
if TT eq 0.d0 then return,dblarr(n)
for i=0,n-1 do begin
  x=hh*nu[i]/(kk*T)
  ;print,x
  if x gt 100.0 then b=0.d0
  if x gt 1.d-3 then b=(2.d0*hh*nu[i]^3/cc^2)/(exp(x)-1.d0) $
    else b=2.0*nu[i]^2*kk*T/cc^2
  bpl[i]=b
endfor
return,bpl
end


function sed,a,o,gastodust=gastodust
if not keyword_set(gastodust) then gastodust=100.d0
dustrho=a.rho/gastodust
pc=3.08572d18
nf=n_elements(o.cabs)
nr=n_elements(a.r)
nz=n_elements(a.z(0,*))
fnuobs=dblarr(nf)
fnunew= dblarr(nf)
for ir=0,nr-1 do begin
   fnuold = fnunew
   fnunew = dblarr(nf)
   rhonew = dustrho(ir,nz-1)
   znew   = a.z(ir,nz-1)
   for iz=nz-2,0,-1 do begin
      zold   = znew
      znew   = a.z(ir,iz)
      rhoold = rhonew
      rhonew = dustrho(ir,iz)
      rho    = 0.5*(rhoold+rhonew)
      dz     = abs(znew-zold)
      dtau   = dz*rho*o.cabs
      xpdt   = exp(-dtau)
      temp   = a.temp(ir,iz)
      fnunew = xpdt*fnunew+ (1-xpdt)*bplanck(o.freq,temp)
   endfor
   for iz=1,nz-1 do begin
      zold   = znew
      znew   = a.z(ir,iz)
      rhoold = rhonew
      rhonew = dustrho(ir,iz)
      rho    = 0.5*(rhoold+rhonew)
      dz     = abs(znew-zold)
      dtau   = dz*rho*o.cabs
      xpdt   = exp(-dtau)
      temp   = a.temp(ir,iz)
      fnunew = xpdt*fnunew+ (1-xpdt)*bplanck(o.freq,temp)
   endfor
   if ir ge 1 then begin
      fnu    = 0.5 * ( fnuold + fnunew )
      surf   = !dpi * ( a.r(ir)^2 - a.r(ir-1)^2 )
      fnuobs = fnuobs + fnu*surf/pc^2
   endif
endfor
a={spectrum:fnuobs,nfr:nf,freq:o.freq,fr_units:-1,obs:0}
return,a
end
