;====================================================================
;               A MORE SOPHISTICATED LOADCT KIND OF THING
;
; For positive color number, it will call loadct,colornr. It will 
; then assign some of the basic color names in a common block.
; For negative color number, it has its own (new) color tables.
;
;  -1     Discrete set of colors
;
;====================================================================
pro colortable,colornr,show=show
common colcodes,black,white,red,green,blue,yellow,magenta,cyan,brown,$
                purple,pink,grey,darkgreen,darkblue,darkbrown,darkyellow
if n_elements(colornr) eq 0 then colornr=5 
if colornr ge 0 then begin
    loadct,colornr
    if(colornr eq 5) then begin
        yellow = floor(!d.table_size*0.75)
        red    = floor(!d.table_size*0.45)
        blue   = floor(!d.table_size*0.20)
        green  = floor(!d.table_size*0.73)
        black  = floor(!d.table_size*0.00)
        white  = floor(!d.table_size*1.00)
        brown  = floor(!d.table_size*0.)
    endif
    if(colornr eq 12) then begin
        ioff   = 2
        red    = floor(!d.table_size*(12./16.)-ioff)
        blue   = floor(!d.table_size*(7./16.)-ioff)
        green  = floor(!d.table_size*(3./16.)-ioff)
        black  = floor(!d.table_size*(0./16.))
        white  = floor(!d.table_size*(16./16.)-ioff)
        cyan   = floor(!d.table_size*(6./16.)-ioff)
        darkgreen = floor(!d.table_size*(2./16.)-ioff)
        purple = floor(!d.table_size*(8./16.)-ioff)
        pink   = floor(!d.table_size*(9./16.)-ioff)
        grey   = floor(!d.table_size*(15./16.)-ioff)
    endif
endif else begin
    ;
    ; My own color tables
    ;
    if(colornr eq -1) then begin
        ;
        ; Discrete colors 
        ;
        colrgb      = fltarr(3,100)
        i=0
        colrgb(*,i)=[0.0,0.0,0.0] & black      =i & i=i+1
        colrgb(*,i)=[1.0,0.0,0.0] & red        =i & i=i+1
        colrgb(*,i)=[0.0,1.0,0.0] & green      =i & i=i+1
        colrgb(*,i)=[0.0,0.0,1.0] & blue       =i & i=i+1
        colrgb(*,i)=[1.0,1.0,0.0] & yellow     =i & i=i+1
        colrgb(*,i)=[1.0,0.0,1.0] & magenta    =i & i=i+1
        colrgb(*,i)=[0.0,1.0,1.0] & cyan       =i & i=i+1
        colrgb(*,i)=[1.0,0.5,0.0] & brown      =i & i=i+1
        colrgb(*,i)=[0.6,0.0,0.0] & darkred    =i & i=i+1
        colrgb(*,i)=[0.0,0.6,0.0] & darkgreen  =i & i=i+1
        colrgb(*,i)=[0.0,0.0,0.6] & darkblue   =i & i=i+1
        colrgb(*,i)=[0.8,0.3,0.0] & darkbrown  =i & i=i+1
        colrgb(*,i)=[0.9,0.7,0.0] & darkyellow =i & i=i+1
        colrgb(*,i)=[1.0,1.0,1.0] & white      =i & i=i+1
        nrcolors = i
        if(!d.name eq 'X') then begin
           colrgb(*,0)          = [0.0,0.0,0.0]
           colrgb(*,nrcolors-1) = [1.0,1.0,1.0]
           dum   = black
           black = white
           white = dum
        endif
        ;
        black      = floor(( black      +0.5) * !d.table_size / nrcolors )
        red        = floor(( red        +0.5) * !d.table_size / nrcolors )
        green      = floor(( green      +0.5) * !d.table_size / nrcolors )
        blue       = floor(( blue       +0.5) * !d.table_size / nrcolors )
        yellow     = floor(( yellow     +0.5) * !d.table_size / nrcolors )
        magenta    = floor(( magenta    +0.5) * !d.table_size / nrcolors )
        cyan       = floor(( cyan       +0.5) * !d.table_size / nrcolors )
        brown      = floor(( brown      +0.5) * !d.table_size / nrcolors )
        darkred    = floor(( darkred    +0.5) * !d.table_size / nrcolors )
        darkgreen  = floor(( darkgreen  +0.5) * !d.table_size / nrcolors )
        darkblue   = floor(( darkblue   +0.5) * !d.table_size / nrcolors )
        darkbrown  = floor(( darkbrown  +0.5) * !d.table_size / nrcolors )
        darkyellow = floor(( darkyellow +0.5) * !d.table_size / nrcolors )
        white      = floor(( white      +0.5) * !d.table_size / nrcolors )
        ;
        r_curr = bytarr(!d.table_size)
        g_curr = bytarr(!d.table_size)
        b_curr = bytarr(!d.table_size)
        for i=0,!d.table_size-1 do begin
            icol = floor (nrcolors * i / !d.table_size)
            r_curr(i) = colrgb(0,icol) * 255
            g_curr(i) = colrgb(1,icol) * 255
            b_curr(i) = colrgb(2,icol) * 255
        endfor
        tvlct,r_curr,g_curr,b_curr
    endif
endelse
if keyword_set(show) then begin
    x=rebin(findgen(2*!d.table_size)/2,2*!d.table_size,2*!d.table_size)
    if(!d.name eq 'X') then begin
        tv,x
    endif else begin
        tv,x,position=[0.1,0.1,0.9,0.9],/device
    endelse
endif
end
