@analyze.pro
@readopac.pro

thick=3.0      ; Postscript line thickness
size=1.4       ; Postscript char size
;
; Read the total flux SED of the model
;
sdskrim = read_spectrum(file='spectrum_rim_no.dat')
sdsk = read_spectrum(file='spectrum_no.dat')
star = read_spectrum(file='starspectrum.inp')
s = sdsk
s.spectrum = s.spectrum+star.spectrum
sr = sdskrim
sr.spectrum = sr.spectrum+star.spectrum
;
; Now plot the SED
; 
!p.thick=thick
!x.thick=thick
!y.thick=thick
!z.thick=thick
!p.charthick=thick
!p.charsize=size
;
set_plot,'ps'
device,file='sed_lsun_norim.eps',/color,bits_per_pixel=24
plot_spectrum,s,xr=[0.3,1000],/xs,/ls
plot_spectrum,star,/oplot,line=1,/ls
device,/close
set_plot,'x'
;
set_plot,'ps'
device,file='sed_145pc_norim.eps',/color,bits_per_pixel=24
plot_spectrum,s,xr=[0.3,1000],/xs,dpc=145.
plot_spectrum,star,dpc=145.,/oplot,line=1
device,/close
set_plot,'x'
;
set_plot,'ps'
device,file='sed_145pc_norim_zoom.eps',/color,bits_per_pixel=24
plot_spectrum,s,xr=[1,100],/xs,dpc=145.,yr=[1d-11,1d-9]
plot_spectrum,star,dpc=145.,/oplot,line=1
device,/close
set_plot,'x'
;
set_plot,'ps'
device,file='sed_lsun.eps',/color,bits_per_pixel=24
plot_spectrum,sr,xr=[0.3,1000],/xs,/ls
plot_spectrum,star,/oplot,line=1,/ls
device,/close
set_plot,'x'
;
set_plot,'ps'
device,file='sed_145pc.eps',/color,bits_per_pixel=24
plot_spectrum,sr,xr=[0.3,1000],/xs,dpc=145.
plot_spectrum,star,dpc=145.,/oplot,line=1
device,/close
set_plot,'x'
;
set_plot,'ps'
device,file='sed_145pc_zoom.eps',/color,bits_per_pixel=24
plot_spectrum,sr,xr=[1,100],/xs,dpc=145.,yr=[1d-11,1d-9]
plot_spectrum,star,dpc=145.,/oplot,line=1
device,/close
set_plot,'x'
;
!p.thick=1
!x.thick=1
!y.thick=1
!z.thick=1
!p.charthick=1
!p.charsize=1


end

