@readdisk
@annot
@readconv
@readaux
@analyze
@readim
@natta
@findhs.pro
@findhp.pro
@compflare.pro
@readscatfrac.pro
@bplanck.pro
@natconst

thick=3.0      ; Postscript line thickness
size=1.4       ; Postscript char size

inuplot1=2
inuplot2=111
im=readim('noscat')
imc=readim('cgnoscat')

rstar=0.d0
mstar=0.d0
tstar=0.d0
openr,1,'starinfo.inp'
readf,1,iformat
readf,1,rstar
readf,1,mstar
readf,1,tstar
close,1

openr,1,'albrecip.info'
ialbrecipe=0
readf,1,ialbrecipe
close,1

a=readdisk('no')
a0=readdisk('a0')
a1=readdisk('a1')
a2=readdisk('a2')
a=readdisk('no')
stralb='a'+strcompress(string(ialbrecipe),/remove_all)
sa=read_spectrum(ext='no')
sb=read_spectrum(ext=stralb)
sc=read_spectrum(ext='cg')
scth=read_spectrum(ext='cgth')
sc2=read_spectrum(ext='cg2')
sc3=read_spectrum(ext='cg3')
sc4=read_spectrum(ext='cg4')
sc5=read_spectrum(ext='cg5')
fa=natta(sa)
;
; Determine the height H_s of the models
;
hs  = findhs(a)
hs0 = findhs(a0)
hs1 = findhs(a1)
hs2 = findhs(a2)
hp  = findhp(a,mstar)
hp0 = findhp(a0,mstar)
hp1 = findhp(a1,mstar)
hp2 = findhp(a2,mstar)
;
; Determine the flaring angles 
;
fl  = compflare(a.r,hs,smooth=3,/index)
fls = compflare(a.r,hs,smooth=3,/index)
fls0= compflare(a.r,hs0,smooth=3,/index)
fls1= compflare(a.r,hs1,smooth=3,/index)
fls2= compflare(a.r,hs2,smooth=3,/index)
;
; Read the reflection fraction as a function of radius for each model
;
eta0=readscatfrac('a0')
eta1=readscatfrac('a1')
eta2=readscatfrac('a2')
;
; Determine the spectrum of the star itself
;
fstr= (rstar^2/pc^2)*pi*bplanck(sa.freq,tstar)
;
; Determine the spectrum of reflected light
;
r   = a.r
dum = fls0*eta0/r
fsc0= fstr*integrate(dum,r)
dum = fls1*eta1/r
fsc1= fstr*integrate(dum,r)
dum = fls2*eta2/r
fsc2= fstr*integrate(dum,r)


;
; Now read loads of data...
;
openr,1,'cgplus.dat'
nnr=0
readf,1,nnr
if n_elements(a.r) ne nnr then stop 
data=dblarr(5,nnr)
readf,1,data
hpc=transpose(data(1,*))
hsc=transpose(data(2,*))
close,1
flc = compflare(a.r,hsc,smooth=3,/index)

openr,1,'albedo.dat'
nalb=0
readf,1,nalb
albedo=dblarr(nalb)
readf,1,albedo
close,1

!p.thick=thick
!x.thick=thick
!y.thick=thick
!z.thick=thick
!p.charthick=thick
!p.charsize=size
!y.minor=1
;!x.minor=2

yrange=[1d-5,1e0]

set_plot,'ps'
device,file='spectrum_albeffect.ps'
plot_spectrum,sa,/lsun,yrange=yrange,xrange=[1,1e3],/xs,/ys
for ialb=0,nalb-1 do begin
   file = 'spectrum_a'+strcompress(string(ialb),/remove_all)+'.dat'
   sd=read_spectrum(file=file)
   case ialb of
      0: begin
         f0=natta(sd)
         end
      1: begin
         f1=natta(sd)
         end
      2: begin
         f2=natta(sd)
         end
   endcase
   plot_spectrum,sd,/lsun,/oplot,line=ialb+1
endfor
annot,0.25,0.32,0.1,0.08,[0,1,2,3],['No Scattering','!4x!X=0.5',$
       '!4x!X=0.8','!4x!X=0.9']
xyouts,0.05,0.92,'R!Ddisk!N = 300 AU'
xyouts,0.75,0.92,'T Tauri (F2)'
device,/close
set_plot,'x'

set_plot,'ps'
device,file='spectrum_albeffect_scatlight.ps'
plot_spectrum,sa,/lsun,yrange=yrange,xrange=[1,1e3],/xs,/ys
for ialb=0,nalb-1 do begin
   file = 'spectrum_a'+strcompress(string(ialb),/remove_all)+'.dat'
   sd=read_spectrum(file=file)
   case ialb of
      0: begin
         sd.spectrum = sd.spectrum+fsc0
         end
      1: begin
         sd.spectrum = sd.spectrum+fsc1
         end
      2: begin
         sd.spectrum = sd.spectrum+fsc2
         end
   endcase
   plot_spectrum,sd,/lsun,/oplot,line=ialb+1
endfor
annot,0.25,0.32,0.1,0.08,[0,1,2,3],['No Scattering','!4x!X=0.5',$
       '!4x!X=0.8','!4x!X=0.9']
xyouts,0.05,0.92,'R!Ddisk!N = 300 AU'
xyouts,0.75,0.92,'T Tauri (F2)'
device,/close
set_plot,'x'

pos1=[0.15,0.4,0.95,0.95]
pos2=[0.15,0.1,0.95,0.4]
xmax=1000
set_plot,'ps'
device,file='spectrum_albeffect_twopanel.ps'
plot,[1,xmax],[1d-5,1d2],yrange=yrange,xrange=[1,xmax],/xs,/ys,$
     /xl,/yl,/nodata,xtickname=[' ',' ',' ',' ',' ',' ',' ',' '],$
     position=pos1,ytitle='!4m!XL!I!4m!X!N [L!D!9n!X!N]' ;;ytitle='!4m!XF!I!4m!X!N [erg cm!E-2!N s!E-1!N]'
plot_spectrum,sa,/lsun,/oplot
for ialb=0,nalb-1 do begin
   file = 'spectrum_a'+strcompress(string(ialb),/remove_all)+'.dat'
   sq=read_spectrum(file=file)
   plot_spectrum,sq,/lsun,/oplot,line=ialb+1
   case ialb of
      0: begin
         f0=natta(sq)
         end
      1: begin
         f1=natta(sq)
         end
      2: begin
         f2=natta(sq)
         end
   endcase
endfor
annot,0.4,0.35,0.1,0.08,[0,1,2,3],['No Scattering','!4x!X=0.5',$
       '!4x!X=0.8','!4x!X=0.9'],position=pos1
xyouts,0.05,0.90,'R!Ddisk!N = 300 AU'
xyouts,0.76,0.90,'T Tauri disk'
plot,3d14/sa.freq,sa.spectrum/sa.spectrum,/xl,yrange=[0,1],/nodata,$
    xrange=[1d0,xmax],xtitle='!4k!X [!4l!Xm]',$
    ;;;ytitle='F!D!4m!X!N!Uscat!N/F!D!4m!X!N!Unoscat!N',$
    ytitle='L!D!4m!X!N!Uscat!N/L!D!4m!X!N!Unoscat!N',$
    position=pos2,/xs,/noerase
for ialb=0,nalb-1 do begin
   file = 'spectrum_a'+strcompress(string(ialb),/remove_all)+'.dat'
   sq=read_spectrum(file=file)
   oplot,3d14/sa.freq,sq.spectrum/sa.spectrum,line=ialb+1
endfor
;annot,0.65,0.4,0.1,0.15,[1,2,3],['!4x!X=0.5',$
;       '!4x!X=0.8','!4x!X=0.9'],position=pos2
device,/close
set_plot,'x'


div=0.35
pos1=[0.15,div,0.95,0.95]
pos2=[0.15,0.1,0.95,div]
noname=[' ',' ',' ',' ',' ',' ',' ',' ']
set_plot,'ps'
device,file='spectrum_comparecg.ps'
plot,[0.1,100],[3d-7,1e-1],yrange=yrange,xrange=[1,1000],$
              position=pos1,/xs,/ys,xtickname=noname,/nodata,/xl,/yl,$
              ytitle='!4m!XL!I!4m!X!N [L!D!9n!X!N]'
plot_spectrum,sa,/lsun,/oplot
plot_spectrum,sc,/lsun,line=2,/oplot
plot_spectrum,scth,/lsun,line=1,/oplot
annot,0.45,0.32,0.1,0.1,[0,1,2],$
    ['1+1D','CG+','CG+, exp(-0.7)'],position=pos1
;xyouts,0.8,0.9,'T Tauri'
xyouts,0.75,0.9,'T Tauri (F2)'
plot,3d14/sa.freq,100*(sc.spectrum/sa.spectrum-1),/xl,/ys,yrange=[-50,50],$
    xtitle='!4k!X [!4l!Xm]',/noerase,position=pos2,xrange=[1,1000],/xs,$
    ytitle='Rel Diff (%)',line=2
oplot,3d14/sa.freq,100*(scth.spectrum/sa.spectrum-1),line=1
device,/close
set_plot,'x'

div=0.35
pos1=[0.15,div,0.95,0.95]
pos2=[0.15,0.1,0.95,div]
noname=[' ',' ',' ',' ',' ',' ',' ',' ']
set_plot,'ps'
device,file='spectrum_testcgscat.ps'
plot,[0.1,100],[3d-7,1e-1],yrange=[1d-2,1e+2],xrange=[1,1000],$
              position=pos1,/xs,/ys,xtickname=noname,/nodata,/xl,/yl,$
              ytitle='!4m!XL!I!4m!X!N [L!D!9n!X!N]'
plot_spectrum,sa,/lsun,/oplot
plot_spectrum,sb,/lsun,/oplot
plot_spectrum,sc,/lsun,line=1,/oplot
plot_spectrum,sc2,/lsun,line=2,/oplot
plot_spectrum,sc3,/lsun,line=3,/oplot
plot_spectrum,sc4,/lsun,line=4,/oplot
annot,0.45,0.45,0.1,0.1,[0,1,2,3,4],$
    ['1+1D','CG+','CG+ recipe 2','CG+ recipe 3','CG+ recipe 4'],position=pos1
;xyouts,0.7,0.9,'T Tauri'
xyouts,0.75,0.9,'T Tauri (F2)'
plot,3d14/sa.freq,100*(sc.spectrum/sa.spectrum-1),/xl,/ys,yrange=[-50,50],$
    xtitle='!4k!X [!4l!Xm]',/noerase,position=pos2,xrange=[1,1000],/xs,$
    ytitle='Rel Diff (%)',line=2
oplot,3d14/sa.freq,100*(sc.spectrum/sa.spectrum-1),line=1
oplot,3d14/sa.freq,100*(sc2.spectrum/sa.spectrum-1),line=2
oplot,3d14/sa.freq,100*(sc3.spectrum/sa.spectrum-1),line=3
oplot,3d14/sa.freq,100*(sc4.spectrum/sa.spectrum-1),line=4
device,/close
set_plot,'x'

set_plot,'ps'
device,file='spectrum_diff.ps'
plot,3d14/sa.freq,sa.spectrum/sa.spectrum,/xl,yrange=[0.4,1],/nodata,$
    xrange=[1,1000],xtitle='!4k!X [!4l!Xm]',/xs,$
    ytitle='F!D!4m!X!N!Uscat!N/F!D!4m!X!N!Unoscat!N'
ialb=0
oplot,3d14/sa.freq,sb.spectrum/sa.spectrum,line=0
oplot,3d14/sa.freq,sc2.spectrum/(sc.spectrum+1d-99),line=2
oplot,3d14/sa.freq,sc3.spectrum/(sc.spectrum+1d-99),line=3
oplot,3d14/sa.freq,sc4.spectrum/(sc.spectrum+1d-99),line=4
annot,0.65,0.35,0.1,0.08,[0,2,3,4],['1+1D',$
       'CG+, m2','CG+, m3','CG+, m4']
device,/close
set_plot,'x'

set_plot,'ps'
device,file='spectrum_testcgrecipe.ps'
plot,3d14/sa.freq,sa.spectrum/sa.spectrum,/xl,yrange=[0.4,1],/nodata,$
    xrange=[1,1000],xtitle='!4k!X [!4l!Xm]',/xs,$
    ytitle='F!D!4m!X!N!Uscat!N/F!D!4m!X!N!Unoscat!N'
ialb=0
oplot,3d14/sa.freq,sb.spectrum/sa.spectrum,line=0
oplot,3d14/sa.freq,sc2.spectrum/(sc.spectrum+1d-99),line=2
;oplot,3d14/sa.freq,sc3.spectrum/(sc.spectrum+1d-99),line=3
;oplot,3d14/sa.freq,sc4.spectrum/(sc.spectrum+1d-99),line=4
oplot,3d14/sa.freq,sc5.spectrum/(sc.spectrum+1d-99),line=1
;annot,0.65,0.35,0.1,0.08,[0,2,3,4],['1+1D',$
;       'CG+, m2','CG+, m3','CG+, m4']
annot,0.55,0.25,0.1,0.08,[0,2,1],['1+1D',$
       'CG+, recip 1','CG+, recip 2']
xyouts,0.03,0.92,'T Tauri (F2)'
device,/close
set_plot,'x'

set_plot,'ps'
device,file='spectrum_comparerecipe.ps'
plot,3d14/sa.freq,sa.spectrum/sa.spectrum-1.0,/xl,yrange=[-100,100],/nodata,$
    xrange=[0.33,1000],xtitle='!4k!X [!4l!Xm]',/xs,$
    ytitle='% Difference'
oplot,3d14/sa.freq,100*(sc.spectrum/sb.spectrum-1.d0),line=0
oplot,3d14/sa.freq,100*(sc2.spectrum/(sb.spectrum+1d-99)-1.d0),line=2
oplot,3d14/sa.freq,100*(sc5.spectrum/(sb.spectrum+1d-99)-1.d0),line=1
annot,0.65,0.92,0.1,0.08,[0,2,1],['Ignore scat',$
       'Recipe 1','Recipe 2']
xyouts,0.03,0.92,'T Tauri (F2)'
xyouts,0.8,0.12,'!4x!X=0.5'
device,/close
set_plot,'x'

set_plot,'ps'
device,file='height.ps'
plot,a.r/au,hp/a.r,/xl,xtitle='R [AU]',ytitle='H/R',yrange=[0,0.5],$
      xrange=[0.1,300],/xs
oplot,a.r/au,hpc/a.r,line=2
oplot,a.r/au,hs/a.r
oplot,a.r/au,hsc/a.r,line=2
xyouts,50,0.05,'H!Dp!N(z=0)'
xyouts,30,0.21,'H!Ds!N'
annot,0.05,0.88,0.1,0.08,[0,2],['1+1D','CG+']
xyouts,0.75,0.92,'T Tauri (F2)'
device,/close
set_plot,'x'

set_plot,'ps'
device,file='height_albeffect.ps'
plot,a.r/au,hp/a.r,/xl,xtitle='R [AU]',ytitle='H/R',yrange=[0.01,0.5],$
      xrange=[0.1,300],/xs,/yl
oplot,a0.r/au,hp0/a0.r,line=1
oplot,a1.r/au,hp1/a1.r,line=2
oplot,a2.r/au,hp2/a2.r,line=3
oplot,a.r/au,hs/a.r
oplot,a0.r/au,hs0/a0.r,line=1
oplot,a1.r/au,hs1/a1.r,line=2
oplot,a2.r/au,hs2/a2.r,line=3
;xyouts,50,0.07,'H!Dp!N(z=0)'
;xyouts,15,0.165,'H!Ds!N'
xyouts,2.0,0.02,'H!Dp!N(z=0)'
xyouts,4.0,0.13,'H!Ds!N'
annot,0.03,0.92,0.1,0.07,[0,1,2,3],['No Scattering','!4x!X=0.5',$
       '!4x!X=0.8','!4x!X=0.9']
;annot,0.5,0.5,0.1,0.07,[0,1,2,3],['No Scattering','!4x!X=0.5',$
;       '!4x!X=0.8','!4x!X=0.9']
xyouts,0.8,0.90,'T Tauri'
device,/close
set_plot,'x'

set_plot,'ps'
device,file='flareindex.ps'
plot,a.r/au,fl,/xl,xtitle='R [AU]',ytitle='!4n!X',yrange=[0,0.3],/ys,$
      xrange=[0.1,300],/xs
oplot,a.r/au,flc,line=2
annot,0.05,0.92,0.1,0.08,[0,2],['1+1D','CG+']
xyouts,0.75,0.92,'T Tauri (F2)'
device,/close
set_plot,'x'

set_plot,'ps'
device,file='intprof_1.3mm.ps'
plot,a.r/au,im.image[*,inuplot1],/xl,/yl,xtitle='R [AU]',$
      ytitle='I [erg/s/cm!U2!N/Hz/ster]',xrange=[0.1,300],/xs
oplot,a.r/au,imc.image[*,inuplot1],line=2
annot,0.05,0.20,0.1,0.08,[0,2],['1+1D','CG+']
xyouts,0.8,0.9,'1.3 mm'
device,/close
set_plot,'x'

set_plot,'ps'
device,file='intprof_10mum.ps'
plot,a.r/au,im.image[*,inuplot2],/xl,/yl,xtitle='R [AU]',$
      ytitle='I [erg/s/cm!U2!N/Hz/ster]',xrange=[0.1,300],/xs
oplot,a.r/au,imc.image[*,inuplot2],line=2
annot,0.05,0.20,0.1,0.08,[0,2],['1+1D','CG+']
xyouts,0.8,0.9,'10 !4l!Xm'
device,/close
set_plot,'x'

div=0.525
pos1=[0.15,div,0.95,0.95]
pos2=[0.15,0.1,0.95,div]
noname=[' ',' ',' ',' ',' ',' ',' ',' ']
set_plot,'ps'
device,file='intprof_twopanel.ps'
plot,a.r/au,im.image[*,inuplot2],/xl,/yl,$
      ytitle='Intensity',xrange=[0.1,300],/xs,$
      position=pos1,xtickname=noname
oplot,a.r/au,imc.image[*,inuplot2],line=2
annot,0.05,0.25,0.1,0.12,[0,2],['1+1D','CG+'],position=pos1
xyouts,0.8,0.9,'10 !4l!Xm'
xyouts,0.4,0.9,'T Tauri (F2)'
plot,a.r/au,im.image[*,inuplot1],/xl,/yl,xtitle='R [AU]',$
      ytitle='Intensity',xrange=[0.1,300],/xs,$
      position=pos2,/noerase,yticks=3
oplot,a.r/au,imc.image[*,inuplot1],line=2
annot,0.05,0.25,0.1,0.12,[0,2],['1+1D','CG+'],position=pos2
xyouts,0.8,0.9,'1.3 mm'
device,/close
set_plot,'x'

!p.thick=1
!x.thick=1
!y.thick=1
!z.thick=1
!p.charthick=1
!p.charsize=1

;
; Write info
;
lstar  = 4*!dpi*rstar^2*ss*tstar^4
lsls   = lstar/LS
;
openw,1,'fluxinfo.txt'
printf,1,'No scattering:'
printf,1,'  F_NIR/F_*   = ',fa.lum_nir/lstar
printf,1,'  F_10mum/F_* = ',fa.lum_tenmic/lstar
printf,1,'  F_FIR/F_*   = ',fa.lum_fir/lstar
printf,1,'Albedo 0.5:'
printf,1,'  F_NIR/F_*   = ',f0.lum_nir/lstar
printf,1,'  F_10mum/F_* = ',f0.lum_tenmic/lstar
printf,1,'  F_FIR/F_*   = ',f0.lum_fir/lstar
printf,1,'Albedo 0.8:'
printf,1,'  F_NIR/F_*   = ',f1.lum_nir/lstar
printf,1,'  F_10mum/F_* = ',f1.lum_tenmic/lstar
printf,1,'  F_FIR/F_*   = ',f1.lum_fir/lstar
printf,1,'Albedo 0.9:'
printf,1,'  F_NIR/F_*   = ',f2.lum_nir/lstar
printf,1,'  F_10mum/F_* = ',f2.lum_tenmic/lstar
printf,1,'  F_FIR/F_*   = ',f2.lum_fir/lstar
close,1

end



