function readfluxerr
openr,1,'fluxerror.dat'
nr=0
readf,1,nr
lstar=0.d0
readf,1,lstar
data=dblarr(5,nr)
readf,1,data
close,1
r=transpose(data(0,*))
alpha=transpose(data(1,*))
hs=transpose(data(2,*))
fluxin=transpose(data(3,*))
fluxout=transpose(data(4,*))
;
; Integrate the flaring angle to see whether everything is consistent
;
hsrint=r*0.0
nr=n_elements(r)
hsrint(0)=hs(0)/r(0)
for ir=1,nr-1 do begin
   hsrint(ir) = hsrint(ir-1) + 0.5 * ( alpha(ir-1) + alpha(ir) ) $
                   * ( alog(r(ir)) - alog(r(ir-1)) )
endfor
;
; Integrate the fluxin and fluxout 
;
fluxintot=0.d0
fluxouttot=0.d0
for ir=1,nr-1 do begin
   fluxintot = fluxintot + !dpi * ( r(ir)^2 - r(ir-1)^2 ) * $
                  0.5 * ( fluxin(ir) +fluxin(ir-1) )
   fluxouttot = fluxouttot + !dpi * ( r(ir)^2 - r(ir-1)^2 ) * $
                  0.5 * ( fluxout(ir) +fluxout(ir-1) )
endfor
fluxintot = fluxintot * 2      ; Two sides
fluxouttot = fluxouttot * 2    ; Two sides
return,{r:r,hs:hs,lstar:lstar,fluxin:fluxin,fluxout:fluxout,$
         hsrint:hsrint,alpha:alpha,fluxintot:fluxintot,fluxouttot:fluxouttot}
end
