function sign,s,x
if(x ge 0.) then return,abs(s) else return,-abs(s)
end


function zbrent,func,x1,x2,tol,_extra=_extra
ITMAX=100
EPS=3.e-8
a=x1
b=x2
fa=call_function(func,a,_extra=_extra)
fb=call_function(func,b,_extra=_extra)
if(((fa gt 0.) and (fb gt 0.)) or ((fa lt 0.) and (fb lt 0.))) then begin
   print,'root must be bracketed for zbrent'
   stop
endif
c=b
fc=fb
for iter=1,ITMAX do begin
    if(((fb gt 0.) and (fc gt 0.)) or ((fb lt 0.) and (fc lt 0.))) then begin
        c=a
        fc=fa
        d=b-a
        e=d
    endif
    if(abs(fc) lt abs(fb)) then begin
        a=b
        b=c
        c=a
        fa=fb
        fb=fc
        fc=fa
    endif
    tol1=2.*EPS*abs(b)+0.5*tol
    xm=.5*(c-b)
    if((abs(xm) le tol1) or (fb eq 0.)) then return,b
    if((abs(e) ge tol1) and (abs(fa) gt abs(fb))) then begin
        s=fb/fa
        if(a eq c) then begin
            p=2.*xm*s
            q=1.-s
        endif else begin
            q=fa/fc
            r=fb/fc
            p=s*(2.*xm*q*(q-r)-(b-a)*(r-1.))
            q=(q-1.)*(r-1.)*(s-1.)
        endelse
        if(p gt 0.) then q=-q
        p=abs(p)
        if(2.*p lt min([3.*xm*q-abs(tol1*q),abs(e*q)])) then begin
            e=d
            d=p/q
        endif else begin
            d=xm
            e=d
        endelse
    endif else begin
        d=xm
        e=d
    endelse
    a=b
    fa=fb
    if(abs(d) gt tol1) then begin
        b=b+d
    endif else begin
        b=b+sign(tol1,xm)
    endelse
    fb=call_function(func,b,_extra=_extra)
endfor
print,'zbrent exceeding maximum iterations'
return,b
END
;  (C) Copr. 1986-92 Numerical Recipes Software =v1.9"217..


